<?php

defined('_JEXEC') or die('Direct Access to '.basename(__FILE__).' is not allowed.');

if (!class_exists('VmConfig')) {
    require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'helpers' . DS . 'config.php');
}

if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

$config = VmConfig::loadConfig();

define('JPATH_ALPHASMS_PLUGIN', JPATH_ROOT.DS.'plugins'.DS.'vmpayment'.DS.'alphasms_send_virtuemart3');
define('JPATH_LOG', JPATH_ROOT.DS.'administrator'.DS.'logs');

//**************************

class plgVmPaymentAlphasms_send_virtuemart3 extends vmPSPlugin {

    function __construct(&$subject, $config) {
        parent::__construct($subject, $config);
    }

    public function send($login, $password, $number, $message, $sender, $query = '') {

        $message = urlencode(html_entity_decode(str_replace('\n', "\n", $message), ENT_QUOTES, 'UTF-8'));

        $url = 'https://alphasms.ua/api/http.php?version=http&login='.urlencode($login).'&pass='.urlencode(html_entity_decode($password)).
            '&to='.urlencode($number).'&message='.$message.
            ($sender ? '&from='.urlencode($sender) : '');

        $viber = $this->params->get('alphasms_viber');
        $viber_name = $this->params->get('alphasms_viber_name');

        if (!empty($viber) && !empty($viber_name)) {
            $url .= '&viber=1&viber_type=TEXT&viber_sms=1&viber_lifetime=900&viber_from='.urlencode($viber_name).'&viber_message='.$message;
        }

        $res = $this->_alphasms_get_url($url);

        exit($res);

        return $res;
    }

    // событие создания заказа
    function plgVmConfirmedOrder($cart, $order)	{

        $login = $this->params->get('alphasms_login');
        $password = $this->params->get('alphasms_psw');
        $sender = $this->params->get('alphasms_sender');
        $msg_new_adm = $this->params->get('alphasms_msg_new_adm');

        $order_number = !empty($order['details']['BT']->order_number) ? $order['details']['BT']->order_number : (!empty($order['details']['ST']->order_number) ? $order['details']['ST']->order_number : '');

        $customer_phone = !empty($order['details']['BT']->phone_2) ? $order['details']['BT']->phone_2 : $order['details']['BT']->phone_1;
        if (!$customer_phone)
            $customer_phone = !empty($order['details']['ST']->phone_2 ? $order['details']['ST']->phone_2 : $order['details']['ST']->phone_1);

        // send sms to admin
        if ($this->params->get('alphasms_send_new_adm') && mb_strlen($msg_new_adm, 'utf8')) {
            $adm_phone = $this->params->get('alphasms_phone');
            $msg_new_adm = str_replace(['{ORDER_NUMBER}', '{CUSTOMER_PHONE}'], [$order_number, $customer_phone], $msg_new_adm);
            if ($this->CheckPhoneNumber($adm_phone)) {
                $result = $this->send($login, $password, $adm_phone, $msg_new_adm, $sender, '');
                if ($result[0]!=-1) {
                    $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_SUCCESS');
                    vmInfo( vmText::_($string,false));
                }
                else{
                    $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_ERROR').' Error code: '.$result[0];
                    vmError( vmText::_($string,false));
                }
            }
            else {
                $string =JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_PHONE_ERROR');
                vmError( vmText::_($string,false));
            }
        }
        // send sms to customer
        $msg_new_cli = $this->params->get('alphasms_msg_new_cli');
        if ($this->params->get('alphasms_send_new_cli') && mb_strlen($msg_new_cli, 'utf8')) {
            $customers_phone = $this->GetCustomersPhone($order);
            $msg_new_cli = str_replace(['{ORDER_NUMBER}', '{CUSTOMER_PHONE}'], [$order_number, $customer_phone], $msg_new_cli);
            if ($this->CheckPhoneNumber($customers_phone)) {
                $result = $this->send($login, $password, $customers_phone, $msg_new_cli, $sender, '');
                if ($result[0]!=-1) {
                    $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_SUCCESS');
                    vmInfo( vmText::_($string,false));
                }
                else {
                    $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_ERROR').' Error code: '.$result[0];
                    vmError( vmText::_($string,false));
                }
            }
            else {
                $string =JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_PHONE_ERROR');
                vmError( vmText::_($string,false));
            }
        }
    }

    //событие изменения статуса заказа
    function plgVmOnUpdateOrderPayment($order, $old_order_status){
        $statusModel = VmModel::getModel('orderstatus');
        $statuses = $statusModel->getOrderStatusNames(false);

        $status = $order->order_status;
        $status_name = JText::_($statuses[$status]['order_status_name']);
        $old_status_name = JText::_($statuses[$old_order_status]['order_status_name']);
        $balance_string="";
        if (mb_strlen($status_name, 'utf8') && mb_strlen($old_status_name, 'utf8')) {
            $login = $this->params->get('alphasms_login');
            $password = $this->params->get('alphasms_psw');
            $sender = $this->params->get('alphasms_sender');
            $alphasms_debug = $this->params->get('alphasms_debug');
            $msg_chg_adm = $this->params->get('alphasms_msg_chg_adm');
            // sms to admin
            if ($this->params->get('alphasms_send_chg_adm') && mb_strlen($msg_chg_adm, 'utf8')) {
                $adm_phone = $this->params->get('alphasms_phone');
                $msg_chg_adm = str_replace('{OLD_STATUS}', $old_status_name, $msg_chg_adm);
                $msg_chg_adm = str_replace('{NEW_STATUS}', $status_name, $msg_chg_adm);
                $msg_chg_adm = str_replace('{ORDER_NUMBER}', $order->order_number, $msg_chg_adm);
                if ($this->CheckPhoneNumber($adm_phone)) {
                    $result = $this->send($login, $password, $adm_phone, $msg_chg_adm, $sender, $query = '');
                    if ($result[0]!=-1) {
                        $this->params->set('alphasms_balance',$result[0]);
                        $balance_string=' '.JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_BALANCE_INFO').' '.$this->get_balance();
                        $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_SUCCESS').($balance_string ? $balance_string:"");
                        vmInfo( vmText::_($string,false));
                    }
                    else {
                        $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_ERROR').' Error code: '.$result[0];
                        vmError( vmText::_($string,false));
                    }
                }
                else {
                    $string =JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_ADM_PHONE_ERROR');
                    vmError( vmText::_($string,false));
                }
            }
            // sms to customer
            $msg_chg_cli = $this->params->get('alphasms_msg_chg_cli');
            if ($this->params->get('alphasms_send_chg_cli') && mb_strlen($msg_chg_cli, 'utf8')) {
                $msg_chg_cli = str_replace('{OLD_STATUS}', $old_status_name, $msg_chg_cli);
                $msg_chg_cli = str_replace('{NEW_STATUS}', $status_name, $msg_chg_cli);
                $msg_chg_cli = str_replace('{ORDER_NUMBER}', $order->order_number, $msg_chg_cli);
                $customer_phone = $this->GetCustomersPhone($order);
                if ($this->CheckPhoneNumber($customer_phone)){
                    $result = $this->send($login, $password, $customer_phone, $msg_chg_cli, $sender, $query = '');
                    if ($result[0]!=-1) {
                        $balance_string=' '.JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_BALANCE_INFO').' '.$this->get_balance();
                        $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_SUCCESS').($balance_string ? $balance_string:"");
                        vmInfo( vmText::_($string,false));
                    }
                    else {
                        $string = JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_ERROR').' Error code: '.$result[0];
                        vmError( vmText::_($string,false));
                    }
                }
                else {
                    $string =JText::_('PLG_ALPHASMS_SEND_VIRTUEMART3_MSG_CLI_PHONE_ERROR');
                    vmError( vmText::_($string,false));
                }
            }
        }
    }


    function _alphasms_get_url($url) {

        if (function_exists("curl_init")) {

            $c = curl_init();
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($c, CURLOPT_TIMEOUT, 60);
            curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);

            curl_setopt($c, CURLOPT_URL, $url);

            $response = curl_exec($c);

            curl_close($c);
        }
        else {

            $arrContextOptions = [
                "ssl" => [
                    "verify_peer" => false,
                    "verify_peer_name" => false,
                ],
            ];

            $response = file_get_contents($url, false, stream_context_create($arrContextOptions));
        }

        return $response;
    }




    function get_balance()
    {
        $m = $this->_alphasms_send_cmd("balance");
        return isset($m[1]) ? false : $m[0];
    }


// ВНУТРЕННИЕ ФУНКЦИИ

// Функция вызова запроса. Формирует URL и делает 3 попытки чтения

    function _alphasms_send_cmd($cmd, $arg = "")
    {
        $login = $this->params->get('alphasms_login');
        $password = $this->params->get('alphasms_psw');

        switch ($cmd) {
            case 'balance':
                $url = "https://alphasms.ua/api/http.php?version=http&login=".urlencode($login)."&pass=".urlencode($password)."&command=balance";
                break;
        }

        if (empty($url)) {
            return false;
        }

        $result = $this->_alphasms_get_url($url);

        switch ($cmd) {
            case 'balance':
                return floatval(str_replace('balance:', '', $result));
        }

        return '';
    }


    public function CheckPhoneNumber($phone)
    {
        $result = true;
        $phone = preg_replace('/\D/', '', $phone);
        if (!preg_match("/^[0-9]{11,14}+$/", $phone)) {
            $result = false;
        }

        return $result;
    }

    function GetCustomersPhone ($order){
        $orderModel = VmModel::getModel('orders');
        $current_order = $orderModel->getOrder($order->virtuemart_order_id);
        //$current_details = $current_order['details']['BT'];
        //$current_phone = $current_order['details']['BT']->phone_2;
        $current_phone = preg_replace('/\D/', '', $current_order['details']['BT']->phone_2);
        return $current_phone;
    }
}